<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>mathops Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284024"></a>mathops Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3><div class="affiliation"><span class="orgname">OpenSIPS Solutions<br></span></div><code class="email">&lt;<a class="email" href="mailto:liviu@opensips.org">liviu@opensips.org</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Liviu</span> <span class="surname">Chircu</span></h3></div></div></div><div><p class="copyright">Copyright © 2013 <a class="ulink" href="http://www.opensips-solutions.com/" target="_top">www.opensips-solutions.com</a></p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id270088">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#sec-overview">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id267958">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id275659">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id273240">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248003">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248009">1.3.1. <code class="varname">decimal_digits</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249595">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249601">1.4.1. 
		<code class="function">math_eval(expression, result_pvar)</code>
		</a></span></dt><dt><span class="section"><a href="#id248911">1.4.2. 
		<code class="function">math_trunc(number, result_pvar)</code>
		</a></span></dt><dt><span class="section"><a href="#id293552">1.4.3. 
		<code class="function">math_floor(number, result_pvar)</code>
		</a></span></dt><dt><span class="section"><a href="#id293637">1.4.4. 
		<code class="function">math_ceil(number, result_pvar)</code>
		</a></span></dt><dt><span class="section"><a href="#id293723">1.4.5. 
		<code class="function">math_round(number, result_pvar[, decimals])</code>
		</a></span></dt><dt><span class="section"><a href="#id293825">1.4.6. 
		<code class="function">math_round_sf(number, result_pvar, figures)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249582">Setting the decimal_digits module parameter</a></dt><dt>1.2. <a href="#id248890"><code class="function">math_eval</code> usage</a></dt><dt>1.3. <a href="#id293533"><code class="function">math_trunc</code> usage</a></dt><dt>1.4. <a href="#id293619"><code class="function">math_floor</code> usage</a></dt><dt>1.5. <a href="#id293704"><code class="function">math_ceil</code> usage</a></dt><dt>1.6. <a href="#id293805"><code class="function">math_round</code> usage</a></dt><dt>1.7. <a href="#id293935"><code class="function">math_round_sf</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id270088"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="sec-overview"></a>1.1. Overview</h2></div></div></div><p>
		The mathops module provides a series of functions which enable various
		floating point operations at OpenSIPS script level.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267958"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id275659"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>No dependencies on other OpenSIPS modules.</em></span>.
			</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id273240"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before 
		running OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span>.
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248003"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248009"></a>1.3.1. <code class="varname">decimal_digits</code> (integer)</h3></div></div></div><p>
		The precision of the results returned by all the module functions.
		The higher the &#8220;<span class="quote">decimal_digits</span>&#8221; value, the more decimal
		digits the results will have.
		</p><p>
		Default value is &#8220;<span class="quote">6</span>&#8221;.
		</p><div class="example"><a name="id249582"></a><p class="title"><b>Example 1.1. Setting the decimal_digits module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("mathops", "decimal_digits", 10)
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249595"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249601"></a>1.4.1. 
		<code class="function">math_eval(expression, result_pvar)</code>
		</h3></div></div></div><p>
		The function evaluates a given expression and writes the results in the
		output pseudo-variable. The expression may contain any number of pseudo
		variables.
		</p><p>
		Currently allowed syntax for specifying an expression:
		</p><div class="itemizedlist"><ul type="disc"><li><p> Nested parantheses </p></li><li><p> binary + - / * operators </p></li></ul></div><p>
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>expression</em></span> - String containing a
			mathematical expression. It can also include pseudo variables. The
			<span class="emphasis"><em>expression</em></span> parameter can only be given as a string.
			</p></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id248890"></a><p class="title"><b>Example 1.2. <code class="function">math_eval</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Compute some random math expression

$avp(1) = "3.141592";
$avp(2) = "2.71828";
$avp(3) = "123.45678";

if (math_eval("$avp(1) * ($avp(3) - ($avp(1) - $avp(2))) / $avp(3)", "$avp(result)")) {
	xlog("Result of expression: $avp(result)\n");
} else {
	xlog("Math eval failed!\n");
}

...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248911"></a>1.4.2. 
		<code class="function">math_trunc(number, result_pvar)</code>
		</h3></div></div></div><p>
		Truncation of a number towards zero. This means that trunc(3.7) = 3.0 and
		trunc(-2.9) = -2.0. 
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>number</em></span> - Number to be truncated. The
			<span class="emphasis"><em>number</em></span> parameter can have the following types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>string</em></span> - statically given</p></li><li><p><span class="emphasis"><em>pvar</em></span> - value of an existing pseudo-variable
				(as string value - it makes no sense to truncate integers)
				</p></li></ul></div></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id293533"></a><p class="title"><b>Example 1.3. <code class="function">math_trunc</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Truncate a random number

$avp(1) = "3.141492";

if (math_trunc("$avp(1)", "$avp(result)")) {
	xlog("Truncate result: $avp(result)\n");
} else {
	xlog("Truncate failed!\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293552"></a>1.4.3. 
		<code class="function">math_floor(number, result_pvar)</code>
		</h3></div></div></div><p>
		Truncates a number, always towards -infinity. This means that floor(3.7) = 3.0
		and floor(-2.9) = -3.0
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>number</em></span> - Number to be truncated. The
			<span class="emphasis"><em>number</em></span> parameter can have the following types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>string</em></span> - statically given</p></li><li><p><span class="emphasis"><em>pvar</em></span> - value of an existing pseudo-variable
				(as string value - it makes no sense to truncate integers)
				</p></li></ul></div></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id293619"></a><p class="title"><b>Example 1.4. <code class="function">math_floor</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Truncate a random number

$avp(1) = "3.141492";

if (math_floor("$avp(1)", "$avp(result)")) {
	xlog("Floor result: $avp(result)\n");
} else {
	xlog("Floor operation failed!\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293637"></a>1.4.4. 
		<code class="function">math_ceil(number, result_pvar)</code>
		</h3></div></div></div><p>
		Truncates a number, always towards +infinity. This means that ceil(3.2) = 4.0
		and ceil(-2.9) = -2.0
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>number</em></span> - Number to be truncated. The
			<span class="emphasis"><em>number</em></span> parameter can have the following types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>string</em></span> - statically given</p></li><li><p><span class="emphasis"><em>pvar</em></span> - value of an existing pseudo-variable
				(as string value - it makes no sense to truncate integers)
				</p></li></ul></div></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id293704"></a><p class="title"><b>Example 1.5. <code class="function">math_ceil</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Truncate a random number

$avp(1) = "3.141492";

if (math_ceil("$avp(1)", "$avp(result)")) {
	xlog("Ceil result: $avp(result)\n");
} else {
	xlog("Ceil operation failed!\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293723"></a>1.4.5. 
		<code class="function">math_round(number, result_pvar[, decimals])</code>
		</h3></div></div></div><p>
		The round function returns the nearest integer, and tie-breaking is done away
		from zero. Examples: round(1.2) = 1.0, round(0.5) = 1.0, round(-0.5) = -1.0
		</p><p>
		By default, the function returns an integer. An additional parameter controls
		the number of decimal digits of the initial number which will be kept. The
		rounding will then be done using the remaining decimal digits, and the result
		will be a float value, represented as a string.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>number</em></span> - Number to be rounded. The
			<span class="emphasis"><em>number</em></span> parameter can have the following types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>string</em></span> - statically given</p></li><li><p><span class="emphasis"><em>pvar</em></span> - value of an existing pseudo-variable
				(as string value - it makes no sense to truncate integers)
				</p></li></ul></div></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li><li><p><span class="emphasis"><em>decimals</em></span> - (pvar / integer as a string) which
			further improves the precision of the rounding.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id293805"></a><p class="title"><b>Example 1.6. <code class="function">math_round</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Rounding PI

$avp(1) = "3.141492";

if (math_round("$avp(1)", "$avp(result)")) {

	# result should be: 3
	xlog("Round result: $avp(result)\n");
} else {
	xlog("Round operation failed!\n");
}

...

if (math_round("$avp(1)", "$avp(result)", "4")) {

	# result should be: "3.1415"
	xlog("Round result: $avp(result)\n");
} else {
	xlog("Round operation failed!\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293825"></a>1.4.6. 
		<code class="function">math_round_sf(number, result_pvar, figures)</code>
		</h3></div></div></div><p>
		To give a simple explanation, rounding to N significant figures is done by 
		first obtaining the number resulted from keeping N significant figures
		(0 padded if necessary), then adjusting it if the N+1'th digit is greater
		or equal to 5.
		</p><p>
		Some examples:
		</p><div class="itemizedlist"><ul type="disc"><li><p> round_sf(17892.987, 1) = 20000 </p><p> round_sf(17892.987, 2) = 18000 </p><p> round_sf(17892.987, 3) = 17900 </p><p> round_sf(17892.987, 4) = 17890 </p><p> round_sf(17892.987, 5) = 17893 </p><p> round_sf(17892.987, 6) = 17893.0 </p><p> round_sf(17892.987, 7) = 17892.99 </p></li></ul></div><p>
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>number</em></span> - Number to be rounded. The
			<span class="emphasis"><em>number</em></span> parameter can have the following types:
			</p><div class="itemizedlist"><ul type="circle"><li><p><span class="emphasis"><em>string</em></span> - statically given</p></li><li><p><span class="emphasis"><em>pvar</em></span> - value of an existing pseudo-variable
				(as string value - it makes no sense to truncate integers)
				</p></li></ul></div></li><li><p><span class="emphasis"><em>result_pvar</em></span> - pseudo-variable which will
			hold the result of the evaluation. Specified as a quoted string.
			</p></li><li><p><span class="emphasis"><em>figures</em></span> - (pvar / integer as a string) which
			further improves the precision of the rounding.
			</p></li></ul></div><p>
		This function can be used from any route.
		</p><div class="example"><a name="id293935"></a><p class="title"><b>Example 1.7. <code class="function">math_round_sf</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# Rounding PI

$avp(1) = "3.141492";

if (math_round_sf("$avp(1)", "$avp(result)", "4")) {

	# result should be: "3.141"
	xlog("Round result: $avp(result)\n");
} else {
	xlog("Round operation failed!\n");
}

...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
