<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Peering Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>Peering Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Irina-Maria</span> <span class="surname">Stanescu</span></h3><code class="email">&lt;<a class="email" href="mailto:ironmissy@gmail.com">ironmissy@gmail.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2008 Juha Heinanen</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5952 $</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275729">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270475">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id268958">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id279386">1.2.1. OpenSIPS Modules</a></span></dt></dl></dd><dt><span class="section"><a href="#id248001">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248007">1.3.1. <code class="varname">aaa_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id249591">1.3.2. <code class="varname">verify_destination_service_type</code> (integer)</a></span></dt><dt><span class="section"><a href="#id249626">1.3.3. <code class="varname">verify_source_service_type</code> (integer)</a></span></dt></dl></dd><dt><span class="section"><a href="#id249662">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id249668">1.4.1. <code class="function">verify_destination()</code></a></span></dt><dt><span class="section"><a href="#id293452">1.4.2. <code class="function">verify_source()</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id249571">Set <code class="varname">aaa_url</code> parameter</a></dt><dt>1.2. <a href="#id249610"><code class="varname">verify_destination_service_type</code> parameter usage</a></dt><dt>1.3. <a href="#id249646"><code class="varname">verify_source_service_type</code> parameter usage</a></dt><dt>1.4. <a href="#id293434"><code class="function">verify_destination()</code> usage</a></dt><dt>1.5. <a href="#id293527"><code class="function">verify_source()</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275729"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270475"></a>1.1. Overview</h2></div></div></div><p> Peering module allows SIP
	providers (operators or organizations) to verify from a broker
	if source or destination of a SIP request is a trusted peer.
        </p><p>
	In order to participate in the trust community provided by a
	broker, each SIP provider registers with the broker the domains
	(host parts of SIP URIs) that they serve.  When a SIP proxy of a
	provider needs to send a SIP request to a non-local domain, it
	can find out from the broker using verify_destination() function
	if the non-local domain is served by a trusted peer.  If so, the
	provider receives from the broker a hash of the SIP request and
	a timestamp that it includes in the request to the non-local
	domain.  When a SIP
	proxy of the non-local domain receives the SIP request, it, in
	turn, can verify from the broker using verify_source() function
	if the request came from a trusted peer.
        </p><p>
        Verification functions communicate with the broker using an AAA
        protocol.  
        </p><p>
        Comments and suggestions for improvements are welcome.
        </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id268958"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id279386"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The module depends on the following modules
			(in the other words 
			the listed modules must be loaded before this module):
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>an AAA implementing module</em></span></p></li></ul></div><p>
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248001"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248007"></a>1.3.1. <code class="varname">aaa_url</code> (string)</h3></div></div></div><p>
		This is the url representing the AAA protocol used and the location of the configuration file of this protocol.
		</p><p>
			If the parameter is set to empty string, the AAA accounting support
			will be disabled (even if compiled).
		</p><p>
		Default value is &#8220;<span class="quote">NULL</span>&#8221;.
		</p><div class="example"><a name="id249571"></a><p class="title"><b>Example 1.1. Set <code class="varname">aaa_url</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("peering", "aaa_url", "radius:/etc/radiusclient-ng/radiusclient.conf")
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249591"></a>1.3.2. <code class="varname">verify_destination_service_type</code> (integer)</h3></div></div></div><p>
		This is the value of the Service-Type AAA attribute to be
		used, when sender of SIP Request verifies request's
	destination using verify_destination() function.
		</p><p>
		Default value is dictionary value of &#8220;<span class="quote">Sip-Verify-Destination</span>&#8221;
		Service-Type.
		</p><div class="example"><a name="id249610"></a><p class="title"><b>Example 1.2. <code class="varname">verify_destination_service_type</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("peering", "verify_destination_service_type", 21)
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249626"></a>1.3.3. <code class="varname">verify_source_service_type</code> (integer)</h3></div></div></div><p>
		This is the value of the Service-Type AAA attribute to be
		used, when receiver of SIP Request verifies request's
	source using verify_source() function.
		</p><p>
		Default value is dictionary value of &#8220;<span class="quote">Sip-Verify-Source</span>&#8221;
		Service-Type.
		</p><div class="example"><a name="id249646"></a><p class="title"><b>Example 1.3. <code class="varname">verify_source_service_type</code> parameter usage</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("peering", "verify_source_service_type", 22)
...
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249662"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249668"></a>1.4.1. <code class="function">verify_destination()</code></h3></div></div></div><p>
		Function verify_destination() queries from
		broker's AAA server if domain (host part) of Request
	URI is served by a trusted peer.  AAA request contains the
	following attributes/values:
		</p><div class="itemizedlist"><ul type="disc"><li><p>User-Name - Request-URI host</p></li><li><p>SIP-URI-User - Request-URI user</p></li><li><p>SIP-From-Tag - From tag</p></li><li><p>SIP-Call-Id - Call id</p></li><li><p>Service-Type - verify_destination_service_type</p></li></ul></div><p>
		Function returns value 1 if domain of Request URI is
	served by a trusted peer and -1 otherwise.  In case of positive
	result, AAA server returns a set of SIP-AVP reply attributes.
	Value of each SIP-AVP is of form:
		 </p><p>
		 [#]name(:|#)value
		 </p><p>
		 Value of each SIP-AVP reply attribute is mapped to an
		 OpenSIPS AVP.  Prefix # in front of name or value indicates a
	string name or string value, respectively.
		 </p><p>
		 One of the SIP-AVP reply attributes contains a string
		 that the source peer must include "as is" in a 
		 P-Request-Hash header when it sends the SIP request to
		 the destination peer.  The string value may, for
		 example, be of form hash@timestamp, where hash contains
		 a hash calculated by the broker based on the attributes
		 of the query and some local information and timestamp
		 is the time when the calculation was done.
		 </p><p>
		 AVP names used in reply attributes are assigned by the
		 broker.
		 </p><p>
		This function can be used from REQUEST_ROUTE and
		FAILURE_ROUTE.
		</p><div class="example"><a name="id293434"></a><p class="title"><b>Example 1.4. <code class="function">verify_destination()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (verify_destination()) {
   append_hf("P-Request-Hash: $avp(prh)\r\n");
}
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293452"></a>1.4.2. <code class="function">verify_source()</code></h3></div></div></div><p>
		Function verify_source() queries from
		broker's AAA server if SIP request was received from
	a trusted peer.  AAA request contains the
	following attributes/values:
		</p><div class="itemizedlist"><ul type="disc"><li><p>User-Name - Request-URI host</p></li><li><p>SIP-URI-User - Request-URI user</p></li><li><p>SIP-From-Tag - From tag</p></li><li><p>SIP-Call-Id - Call id</p></li><li><p>SIP-Request-Hash - body of P-Request-Hash header</p></li><li><p>Service-Type - verify_source_service_type</p></li></ul></div><p>
		Function returns value 1 if SIP request was received
	from a trusted peer and -1 otherwise.  In case of positive
	result, AAA server may return a set of SIP-AVP reply
	attributes.  Value of each SIP-AVP is of form:
		 </p><p>
		 [#]name(:|#)value
		 </p><p>
		 Value of each SIP-AVP reply attribute is mapped to an
		 OpenSIPS 
		 AVP.  Prefix # in front of name or value indicates a
	string name or string value, respectively.
		 </p><p>
		 AVP names used in reply attributes are
		 assigned by the broker.
		 </p><p>
		This function can be used from REQUEST_ROUTE and
		FAILURE_ROUTE.
		</p><div class="example"><a name="id293527"></a><p class="title"><b>Example 1.5. <code class="function">verify_source()</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_present_hf("P-Request-Hash")) {
   if (verify_source()) {
      xlog("L_INFO", "Request came from trusted peer\n")
   }
}
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
