<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Stun Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249238"></a>Stun Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Razvan</span> <span class="surname">Pistolea</span></h3><code class="email">&lt;<a class="email" href="mailto:razvy000@yahoo.com">razvy000@yahoo.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision:$</td><td align="left">$Date$</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id275154">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id269750">1.1. Overview</a></span></dt><dd><dl><dt><span class="section"><a href="#id248897">1.1.1.  The idea</a></span></dt><dt><span class="section"><a href="#id248910">1.1.2.  Basic Operation</a></span></dt><dt><span class="section"><a href="#id248007">1.1.3.  Supported STUN Attributes </a></span></dt></dl></dd><dt><span class="section"><a href="#id248363">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248368">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248386">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248412">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248418">1.3.1. 
				<code class="varname">primary_ip</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id248452">1.3.2. 
				<code class="varname">primary_port</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id293406">1.3.3. 
				<code class="varname">alternate_ip</code> (str)
			</a></span></dt><dt><span class="section"><a href="#id293434">1.3.4. 
				<code class="varname">alternate_port</code> (str)
			</a></span></dt></dl></dd><dt><span class="section"><a href="#id293464">1.4. Exported MI Functions</a></span></dt></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248432">Set
					<code class="varname">primary_ip</code> parameter
				</a></dt><dt>1.2. <a href="#id248466">Set <code class="varname">primary_port</code> parameter
				</a></dt><dt>1.3. <a href="#id293418">Set
					<code class="varname">alternate_ip</code> parameter
				</a></dt><dt>1.4. <a href="#id293447">Set
					<code class="varname">alternate_port</code> parameter
				</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id275154"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id269750"></a>1.1. Overview</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248897"></a>1.1.1.  The idea</h3></div></div></div><p>
			A stun server working with the same port as SIP (5060) in order to
			gain accurate information. The benefit would be an exact external 
			address in the case of NATs translating differently when given 
			different destination ports.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248910"></a>1.1.2.  Basic Operation</h3></div></div></div><p>
			The stun server will use 4 sockets:
			</p><div class="itemizedlist"><ul type="disc"><li>socket1 = ip1 : port1</li><li>socket2 = ip1 : port2</li><li>socket3 = ip2 : port1</li><li>socket4 = ip2 : port2</li></ul></div><p>
			</p><p>
				The sockets come from existing SIP sockets or are created.
			</p><p>
				Socket1 must allways be a SIP UDP listener from OpenSIPS.
			</p><p>
				The server will create a separate process.
				This process will listen for data on created sockets.
				The server will register a callback function to SIP.
				This function is called when a specific (stun)header is found.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248007"></a>1.1.3.  Supported STUN Attributes </h3></div></div></div><p>
				This stun implements RFC3489 (and XOR_MAPPED_ADDRESS from 
				RFC5389)
			</p><p>
			</p><div class="itemizedlist"><ul type="disc"><li>MAPPED_ADDRESS</li><li>RESPONSE_ADDRESS</li><li>CHANGE_REQUEST</li><li>SOURCE_ADDRESS</li><li>CHANGED_ADDRESS</li><li>ERROR_CODE</li><li>UNKNOWN_ATTRIBUTES</li><li>REFLECTED_FROM</li><li>XOR_MAPPED_ADDRESS</li></ul></div><p>
			</p><p> Not supported attributes:</p><p>
			</p><div class="itemizedlist"><ul type="disc"><li>USERNAME</li><li>PASSWORD</li><li>MESSAGE_INTEGRITY</li></ul></div><p>
			and associated ERROR_CODEs
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248363"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248368"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
			The following modules must be loaded before this module:
			</p><p>
			<span class="emphasis"><em>None</em></span>.
			</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248386"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
			The following libraries or applications must be installed before 
			running OpenSIPS with this module loaded:
				</p><div class="itemizedlist"><ul type="disc"><li><p>
							<span class="emphasis"><em>None</em></span>.
						</p></li></ul></div><p>
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248412"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248418"></a>1.3.1. 
				<code class="varname">primary_ip</code> (str)
			</h3></div></div></div><p>
			The ip of the an interface configured as UDP SIP listener
			in OpenSIPS. It is a mandatory paramter, by default empty.
			</p><div class="example"><a name="id248432"></a><p class="title"><b>Example 1.1. Set
					<code class="varname">primary_ip</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","primary_ip","192.168.0.100")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248452"></a>1.3.2. 
				<code class="varname">primary_port</code> (str)
			</h3></div></div></div><p>
			The port configured (together with the primary_ip) as an UDP SIP
			listener in OpenSIPS. It is a mandatory paramter, by default 5060.
			</p><div class="example"><a name="id248466"></a><p class="title"><b>Example 1.2. Set <code class="varname">primary_port</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","primary_port","5060")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293406"></a>1.3.3. 
				<code class="varname">alternate_ip</code> (str)
			</h3></div></div></div><p>
			Another ip from another interface. It is mandatory to be set,
			default is empty (not set).
			</p><div class="example"><a name="id293418"></a><p class="title"><b>Example 1.3. Set
					<code class="varname">alternate_ip</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","alternate_ip","11.22.33.44")
...
				</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293434"></a>1.3.4. 
				<code class="varname">alternate_port</code> (str)
			</h3></div></div></div><p>
			Another port used by STUN. It is mandatory to be set, default
			value is 3478 (default STUN port).
			</p><div class="example"><a name="id293447"></a><p class="title"><b>Example 1.4. Set
					<code class="varname">alternate_port</code> parameter
				</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("stun","alternate_port","3479")
...
				</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293464"></a>1.4. Exported MI Functions</h2></div></div></div></div></div></div></body></html>
